"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _createFunction = _interopRequireDefault(require("@polkadot/storage/utils/createFunction"));

var _Modules = require("@polkadot/types/Metadata/v0/Modules");

var _types = require("@polkadot/types");

var _util = require("@polkadot/util");

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
// Small helper function to factorize code on this page.
const createMethod = (method, key, _ref) => {
  let documentation = _ref.documentation,
      type = _ref.type;
  return (0, _createFunction.default)(new _types.Text('Block'), new _types.Text(method), {
    documentation: new _types.Vector(_types.Text, documentation),
    modifier: new _Modules.StorageFunctionModifier(0),
    type: new _Modules.StorageFunctionType(type, (0, _util.isString)(type) ? 0 : 1),
    toJSON: () => key
  }, {
    isUnhashed: false,
    key
  });
};

var _default = {
  bestHash: createMethod('bestHash', 'bst:hsh', {
    documentation: ['Best hash'],
    type: 'Hash'
  }),
  bestNumber: createMethod('bestNumber', 'bst:num', {
    documentation: ['Best block'],
    type: 'BlockNumber'
  }),
  blockByHash: createMethod('blockByHash', 'blk:hsh:', {
    documentation: ['Retrieve block by hash'],
    type: {
      key: 'Hash',
      value: 'Bytes'
    }
  }),
  hashByNumber: createMethod('hashByNumber', 'hsh:num:', {
    documentation: ['Retrieve hash by number'],
    type: {
      key: 'u256',
      value: 'Hash'
    }
  }),
  headerByHash: createMethod('headerByHash', 'hdr:hsh:', {
    documentation: ['Retrieve header by hash'],
    type: {
      key: 'Hash',
      value: 'Bytes'
    }
  })
};
exports.default = _default;