"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeArrayU8a;

var _util = require("@polkadot/util");

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function decodeArrayU8a(db, createKey) {
  return {
    del: keyParam => db.del(createKey(keyParam)),
    get: keyParam => {
      const u8a = db.get(createKey(keyParam));

      if (u8a === null) {
        return [];
      }

      const length = (0, _util.u8aToBn)(u8a.subarray(0, 4), true).toNumber();
      const result = [];
      let offset = 4;

      for (let index = 0; index < length; index++, offset += 32) {
        result.push(u8a.subarray(offset, offset + 32));
      }

      return result;
    },
    set: (value, keyParam) => db.put(createKey(keyParam), (0, _util.u8aConcat)((0, _util.bnToU8a)(value.length, 32, true), _util.u8aConcat.apply(null, value))),
    onUpdate: updater => {
      throw new Error("No subscriber available for db/arrayU8a");
    }
  };
}